package org.opencdmp.filetransformer.docx.web.controller;

import org.opencdmp.commonmodels.models.FileEnvelopeModel;
import org.opencdmp.commonmodels.models.description.DescriptionModel;
import org.opencdmp.commonmodels.models.dmp.DmpModel;
import org.opencdmp.filetransformerbase.interfaces.FileTransformerClient;
import org.opencdmp.filetransformerbase.interfaces.FileTransformerConfiguration;
import org.opencdmp.filetransformer.docx.service.wordfiletransformer.WordFileTransformerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api/file-transformer")
public class FileTransformerController implements org.opencdmp.filetransformerbase.interfaces.FileTransformerController {

    private final FileTransformerClient fileTransformerExecutor;

    @Autowired
    public FileTransformerController(WordFileTransformerService fileTransformerExecutor) {
        this.fileTransformerExecutor = fileTransformerExecutor;
    }

    public FileEnvelopeModel exportDmp(@RequestBody DmpModel dmpDepositModel, @RequestParam(value = "format",required = false)String format) throws Exception {
        return fileTransformerExecutor.exportDmp(dmpDepositModel, format);
    }

    public FileEnvelopeModel exportDescription(@RequestBody DescriptionModel descriptionModel, @RequestParam(value = "format",required = false)String format) throws Exception {
        return fileTransformerExecutor.exportDescription(descriptionModel, format);
    }

    public DmpModel importFileToDmp(@RequestBody FileEnvelopeModel fileEnvelope) {
        return fileTransformerExecutor.importDmp(fileEnvelope);
    }

    public DescriptionModel importFileToDescription(@RequestBody FileEnvelopeModel fileEnvelope) {
        return fileTransformerExecutor.importDescription(fileEnvelope);
    }

    public FileTransformerConfiguration getSupportedFormats() {
        return fileTransformerExecutor.getConfiguration();
    }
}
